Đến nội dung


Hình ảnh
* * * - - 5 Bình chọn

[yêu cầu &thảo luận] lisp vẽ mặt bằng kết cấu


  • Please log in to reply
118 replies to this topic

#1 phongtran86

phongtran86

    biết lệnh offset

  • Members
  • PipPipPip
  • 177 Bài viết
Điểm đánh giá: 22 (tàm tạm)

Đã gửi 17 May 2013 - 09:17 AM

21028_hinh_abc.jpg

 

Hôm trước mình có tải lisp offset muti của ketxu http://www.cadviet.c...ac-biet/page-2. Mình chợt nảy ra ý tưởng: Từ trục định vị ta offset như trên hình vẽ rồi fillet ( hoặc trim) để ra được mbkc--> ta tổng hợp đc các bước này thì từ trục dình vị qua 1 lệnh vẽ ta đc mbkc 1 cách tương đối. Anh em thử ng/c về thuật toán làm việc trên có khả thi không.

Anh bạn mình đang đề xuất thuât toán: từ trục định vị --> dung lệnh BO các vung kín trong trục định vị, offset 110 vào trong vao layer hien hanh->>xóa bo cũ--- bo hình chữ nhật ngoài cùng trục định vị offset ra ngoài. Mọi người thử có khả thi không.


  • 1

#2 Doan Van Ha

Doan Van Ha

    biết lệnh adcenter

  • CADViet Team
  • PipPipPipPipPipPipPip
  • 5454 Bài viết
Điểm đánh giá: 2626 (tuyệt vời)

Đã gửi 17 May 2013 - 10:00 AM

Khả thi. Không cần offset. Cũng không cần Bo. Chỉ có điều hơi mất công viết. Mức độ phức tạp còn phụ thuộc kiểu thẳng/xiên/cong của đường trục và các bề rộng 2 bên trục của chúng.


  • 1

* Chỉ nên yêu cầu Lisp khi bạn làm việc đó mất cả ngày nhưng họ chỉ viết 1 giờ. Đừng nêu yêu cầu Lisp khi bạn chỉ làm 1 giờ nhưng bắt họ phải mất cả ngày.

* Nhờ viết lisp cũng như đi khám bệnh. Chỉ gởi căn cước và than sắp chết thì không bác sỹ nào cứu sống được.


#3 xaydungit.vn

xaydungit.vn

    biết vẽ arc

  • Members
  • PipPip
  • 48 Bài viết
Điểm đánh giá: 54 (tàm tạm)

Đã gửi 17 May 2013 - 10:11 AM

@phongtran86 xem Video này nhé :

 


  • 2

#4 phongtran86

phongtran86

    biết lệnh offset

  • Members
  • PipPipPip
  • 177 Bài viết
Điểm đánh giá: 22 (tàm tạm)

Đã gửi 17 May 2013 - 10:12 AM

Bác thử bỏ chút công viết xem. Em cũng đang mày mò lisp mà chưa đủ trình :(


  • 0

#5 Doan Van Ha

Doan Van Ha

    biết lệnh adcenter

  • CADViet Team
  • PipPipPipPipPipPipPip
  • 5454 Bài viết
Điểm đánh giá: 2626 (tuyệt vời)

Đã gửi 17 May 2013 - 10:16 AM

Xaydung.IT đã viết ở video trên rồi kìa! Cái này chắc dùng .net? Bạn ngõ lời xin bạn Xaydung.IT cho nó nhanh.


  • 1

* Chỉ nên yêu cầu Lisp khi bạn làm việc đó mất cả ngày nhưng họ chỉ viết 1 giờ. Đừng nêu yêu cầu Lisp khi bạn chỉ làm 1 giờ nhưng bắt họ phải mất cả ngày.

* Nhờ viết lisp cũng như đi khám bệnh. Chỉ gởi căn cước và than sắp chết thì không bác sỹ nào cứu sống được.


#6 phongtran86

phongtran86

    biết lệnh offset

  • Members
  • PipPipPip
  • 177 Bài viết
Điểm đánh giá: 22 (tàm tạm)

Đã gửi 17 May 2013 - 10:18 AM

@xaydungit.vn bác cho xin lisp trên đc ko


  • 0

#7 phongtran86

phongtran86

    biết lệnh offset

  • Members
  • PipPipPip
  • 177 Bài viết
Điểm đánh giá: 22 (tàm tạm)

Đã gửi 17 May 2013 - 10:49 AM

Up lên nào là up lên nào


  • 0

#8 phongtran86

phongtran86

    biết lệnh offset

  • Members
  • PipPipPip
  • 177 Bài viết
Điểm đánh giá: 22 (tàm tạm)

Đã gửi 17 May 2013 - 11:07 AM

việc vẽ mbkc thì ta có trục định vị bên kiến trúc cơ bản rồi. Mình copy với có lisp offset ra thì có vẻ tiện hơn là lại phải nhập khoảng cách trục định vị lại rồi nhập bảng như của xaydungIT. Up cho mọi người vào giúp nào.


  • 0

#9 Detailing

Detailing

    biết lệnh imageclip

  • Members
  • PipPipPipPipPipPipPip
  • 667 Bài viết
Điểm đánh giá: 278 (khá)

Đã gửi 17 May 2013 - 01:31 PM

@phongtran86 xem Video này nhé :

 

cái này vẽ mặt bằng gì nhỉ? cột có kích thước bằng nhau, chỉ nằm trên giao của trục, và luôn đặt ngay tim cột, trên mặt bằng chi chít cột, tường thì kín mít vẽ ra xong ngồi chỉnh lại nhiều khi tự vẽ lúc đầu bằng MLINE còn nhanh hơn, 1 tiện ích cực kỳ ... bất tiện  :wacko:

p/s: bên này thấy có yêu cầu free ứng dụng bằng .NET đây, chủ topic có thể thử vận may: http://www.tramx.vn/...god430201322149

Good luck!


  • 0

Ideas don't matter, execution does!

1908412_308002392716743_8165279281236341


#10 phongtran86

phongtran86

    biết lệnh offset

  • Members
  • PipPipPip
  • 177 Bài viết
Điểm đánh giá: 22 (tàm tạm)

Đã gửi 17 May 2013 - 02:12 PM

up lên nào. Bên cadviet toàn cao thủ lisp đó :)


  • 0

#11 Doan Van Ha

Doan Van Ha

    biết lệnh adcenter

  • CADViet Team
  • PipPipPipPipPipPipPip
  • 5454 Bài viết
Điểm đánh giá: 2626 (tuyệt vời)

Đã gửi 17 May 2013 - 02:23 PM

Bạn xem lại bài #2 ở trên và trình bày bài toán tổng quát của bạn xem. Nếu đơn giản thì tui mần cho, còn phức tạp thì chắc phải đợi vì hiện giờ không có nhiều thời gian.


  • 1

* Chỉ nên yêu cầu Lisp khi bạn làm việc đó mất cả ngày nhưng họ chỉ viết 1 giờ. Đừng nêu yêu cầu Lisp khi bạn chỉ làm 1 giờ nhưng bắt họ phải mất cả ngày.

* Nhờ viết lisp cũng như đi khám bệnh. Chỉ gởi căn cước và than sắp chết thì không bác sỹ nào cứu sống được.


#12 phongtran86

phongtran86

    biết lệnh offset

  • Members
  • PipPipPip
  • 177 Bài viết
Điểm đánh giá: 22 (tàm tạm)

Đã gửi 17 May 2013 - 02:52 PM

mức độ chỉ dừng là các trục là đường thẳng (ko có cong và xiên). Còn bề rộng là a nhập vào mặc định giá trị 110. Trục định vị cong xiên thì tính sau vậy :)

Bác mần giúp em phát :D. Cảm ơn bác nhiều


  • 0

#13 NguyenNgocSon

NguyenNgocSon

    biết dimbaseline

  • Members
  • PipPipPipPipPip
  • 368 Bài viết
Điểm đánh giá: 39 (tàm tạm)

Đã gửi 17 May 2013 - 03:40 PM

@phongtran86 xem Video này nhé :

 

Bạn cho hỏi tạo cái khung nhìn trên Form đấy bằng VBA có được ko ?


  • 0

#14 phongtran86

phongtran86

    biết lệnh offset

  • Members
  • PipPipPip
  • 177 Bài viết
Điểm đánh giá: 22 (tàm tạm)

Đã gửi 17 May 2013 - 07:47 PM

Chờ mong anh hà :)


  • 0

#15 Tue_NV

Tue_NV

    KS Võ Quang Tuệ

  • Moderator
  • PipPipPipPipPipPipPip
  • 4296 Bài viết
Điểm đánh giá: 3805 (đỉnh cao)

Đã gửi 17 May 2013 - 09:34 PM

Cái này, mình nhớ chính xác là đã có rồi, của bạn Phạm Ngọc Tú trong topic Viết Lisp Yêu cầu (Phần II). 

Giờ chừ mà tìm chắc "đoạ"  :lol:

Bạn liên hệ với tác giả thử xem.

Viết cũng được thôi, mà mất thời gian quá  ;)


  • 0

#16 xaydungit.vn

xaydungit.vn

    biết vẽ arc

  • Members
  • PipPip
  • 48 Bài viết
Điểm đánh giá: 54 (tàm tạm)

Đã gửi 17 May 2013 - 09:49 PM

Gửi bạn phongtran86 dùng tạm

Bạn dùng lệnh NETLOAD trỏ đến file MBKC1.dll sau đó dùng lệnh MBKC1 và thực hiện như video (Phiên bản chạy trên AutoCAD 2013 và 2014)

Link : http://www.cadviet.c...06039_mbkc1.rar

 

PS : Ai thấy vẽ bằng Mline nhanh hơn thì cứ vẽ xin đừng chém :D

 

[media][\media]


  • 0

#17 phongtran86

phongtran86

    biết lệnh offset

  • Members
  • PipPipPip
  • 177 Bài viết
Điểm đánh giá: 22 (tàm tạm)

Đã gửi 17 May 2013 - 10:30 PM

Bác Tue_NV nhớ từ khóa tìm giúp em với. Em tìm nãy h không được :)


  • 0

#18 Doan Van Ha

Doan Van Ha

    biết lệnh adcenter

  • CADViet Team
  • PipPipPipPipPipPipPip
  • 5454 Bài viết
Điểm đánh giá: 2626 (tuyệt vời)

Đã gửi 18 May 2013 - 07:10 AM

Lisp vẽ hệ tường theo lưới trục.

67029_untitled1_1.png

 

;Doan Van Ha - CADViet.com - Ngay 17/05/2013
;Chuc nang: ve luoi tuong theo he truc.
(defun C:HA(/ lstd lstn lstg1 lstg x y)
 (vl-load-com)
 (command "undo" "be")
 (princ "\nChon cac Line duong truc...")
 (foreach ent (vl-remove-if 'listp (mapcar 'cadr (ssnamex (ssget '((0 . "LINE"))))))
  (if (equal (car (cdr (assoc 10 (entget ent)))) (car (cdr (assoc 11 (entget ent)))) 1E-8)
   (setq lstd (cons ent lstd))
   (setq lstn (cons ent lstn))))
 (setq lstd (vl-sort lstd '(lambda (e1 e2) (< (car (cdr (assoc 10 (entget e1)))) (car (cdr (assoc 10 (entget e2))))))))
 (setq lstn (vl-sort lstn '(lambda (e1 e2) (< (cadr (cdr (assoc 10 (entget e1)))) (cadr (cdr (assoc 10 (entget e2))))))))
 (or kc (setq kc 110))
 (setq kc (cond ((getdist (strcat "\nBe day tuong <" (rtos kc 2 2) ">:"))) (kc)))
 (foreach entn lstn
  (setq lstg1 nil)
  (foreach entd lstd
   (if (setq giao (car (HA:Giao (vlax-ename->vla-object entn) (vlax-ename->vla-object entd) acExtendNone)))
    (setq lstg1 (cons giao lstg1))))
  (if lstg1 (setq lstg (cons lstg1 lstg))))
 (HA1 (caar lstg) (last (last lstg)) kc)
 (setq x 0)
 (repeat (1- (length lstg))
  (setq y 0)
  (repeat (1- (length (nth x lstg)))
   (HA (nth y (nth (1+ x) lstg)) (nth (1+ y) (nth x lstg)) kc)
   (setq y (1+ y)))
  (setq x (1+ x)))
 (command "undo" "e") 
 (princ))
(defun HA:Giao(obj1 obj2 mode / l r)
 (setq l (vlax-invoke obj1 'intersectwith obj2 mode))
 (repeat (/ (length l) 3)
  (setq r (cons (list (car l) (cadr l) (caddr l)) r) l (cdddr l)))
 r)
(defun HA(p1 p3 kc / p1x p3x)
 (setq p1x (list (+ (min (car p1) (car p3)) kc) (+ (min (cadr p1) (cadr p3)) kc))
       p3x (list (- (max (car p1) (car p3)) kc) (- (max (cadr p1) (cadr p3)) kc)))
 (command "rectang" "non" p1x "non" p3x))
(defun HA1(p1 p3 kc / p1x p3x)
 (setq p1x (list (- (min (car p1) (car p3)) kc) (- (min (cadr p1) (cadr p3)) kc))
       p3x (list (+ (max (car p1) (car p3)) kc) (+ (max (cadr p1) (cadr p3)) kc)))
 (command "rectang" "non" p1x "non" p3x))

  • 1

* Chỉ nên yêu cầu Lisp khi bạn làm việc đó mất cả ngày nhưng họ chỉ viết 1 giờ. Đừng nêu yêu cầu Lisp khi bạn chỉ làm 1 giờ nhưng bắt họ phải mất cả ngày.

* Nhờ viết lisp cũng như đi khám bệnh. Chỉ gởi căn cước và than sắp chết thì không bác sỹ nào cứu sống được.


#19 ketxu

ketxu

    Copier - Paster - Editor

  • Moderator
  • PipPipPipPipPipPipPip
  • 5685 Bài viết
Điểm đánh giá: 2606 (tuyệt vời)

Đã gửi 18 May 2013 - 07:48 AM

^^ketxu góp link cũ để tham khảo

 

http://www.cadviet.c...han-2/?p=109830


  • 0

Thành viên nhóm CadMagic.
Mời bạn ghé thăm facebook nhóm - Page viết lisp theo yêu cầu  :
CAD MAGIC


#20 phongtran86

phongtran86

    biết lệnh offset

  • Members
  • PipPipPip
  • 177 Bài viết
Điểm đánh giá: 22 (tàm tạm)

Đã gửi 18 May 2013 - 08:37 AM

mấy bác tuyệt quá. vote cho 2 bác mà ko đc. You have reached your quota of positive votes for the day :(


  • 0